type doc = SEQ of doc * doc
         | TEXT of string
         | B of doc
         | EM of doc
         | I of doc
         | PL of doc
         | S of doc
         | TT of doc
         | U of doc
         | F0 of doc
         | F1 of doc
         | F2 of doc
         | F3 of doc
         | F4 of doc
         | F5 of doc
         | F6 of doc
         | F7 of doc
         | F8 of doc
         | F9 of doc
         | CR of doc
         | CG of doc
         | CB of doc
         | CC of doc
         | CM of doc
         | CY of doc
         | CK of doc
         | CW of doc


let _ = Random.init (int_of_string(Array.get Sys.argv 2))
let randChar () = 
      match (Random.int 5) with
      | 0 -> "\t"
      | 1 -> " "
      | 2 -> "\n"
      | 3 -> "\r"
      | _ -> "a"

let rec charSeq = function 
      | 0 -> []
      | i -> randChar () :: charSeq (i - 1)
let implode cs = List.fold_left (fun s c -> c ^ s) "" cs
let getNext () = implode (charSeq (Random.int 10))
let numLeft = ref (int_of_string(Array.get Sys.argv 1))
let doOne () = numLeft := (! numLeft) - 1
let rec randNode () = 
      match (!numLeft) with
      | 0 -> TEXT "leaf"
      | _ -> 
        let r = Random.int 27
        in (doOne ();
            (match r with
             | 0 -> SEQ (randNode (), randNode ())
             | 1 -> TEXT (getNext ())
             | 2 -> B (randNode ()) 
             | 3 -> EM (randNode ())
             | 4 -> I (randNode ())
             | 5 -> PL (randNode ())
             | 6 -> S (randNode ())
             | 7 -> TT (randNode ())
             | 8 -> U (randNode ())
             | 9 -> F0 (randNode ())
             | 10 -> F1 (randNode ())
             | 11 -> F2 (randNode ())
             | 12 -> F3 (randNode ())
             | 13 -> F4 (randNode ())
             | 14 -> F5 (randNode ())
             | 15 -> F6 (randNode ())
             | 16 -> F7 (randNode ())
             | 17 -> F8 (randNode ())
             | 18 -> F9 (randNode ())
             | 19 -> CR (randNode ())
             | 20 -> CG (randNode ())
             | 21 -> CB (randNode ())
             | 22 -> CC (randNode ())
             | 23 -> CM (randNode ())
             | 24 -> CY (randNode ())
             | 25 -> CK (randNode ())
             | 26 -> CW (randNode ())
             | _ -> assert(false)))
let rec fullSeq () =
         let doc = randNode ()
         in match (!numLeft) with
         | 0 -> doc
         | _ -> SEQ(doc, fullSeq())
let rec toString = function
      | SEQ (node, node') -> toString node ^ toString node'
      | TEXT string -> string
      | B node -> "<B>" ^ toString node ^ "</B>"
      | EM node -> "<EM>" ^ toString node ^ "</EM>"
      | I node ->"<I>" ^ toString node ^ "</I>"
      | PL node ->"<PL>" ^ toString node ^ "</PL>"
      | S node ->"<S>" ^ toString node ^ "</S>"
      | TT node ->"<TT>" ^ toString node ^ "</TT>"
      | U node ->"<U>" ^ toString node ^ "</U>"
      | F0 node ->"<0>" ^ toString node ^ "</0>"
      | F1 node ->"<1>" ^ toString node ^ "</1>"
      | F2 node ->"<2>" ^ toString node ^ "</2>"
      | F3 node ->"<3>" ^ toString node ^ "</3>"
      | F4 node ->"<4>" ^ toString node ^ "</4>"
      | F5 node ->"<5>" ^ toString node ^ "</5>"
      | F6 node ->"<6>" ^ toString node ^ "</6>"
      | F7 node ->"<7>" ^ toString node ^ "</7>"
      | F8 node ->"<8>" ^ toString node ^ "</8>"
      | F9 node ->"<9>" ^ toString node ^ "</9>"
      | CR node ->"<r>" ^ toString node ^ "</r>"
      | CG node ->"<g>" ^ toString node ^ "</g>"
      | CB node ->"<b>" ^ toString node ^ "</b>"
      | CC node ->"<c>" ^ toString node ^ "</c>"
      | CM node ->"<m>" ^ toString node ^ "</m>"
      | CY node ->"<y>" ^ toString node ^ "</y>"
      | CK node ->"<k>" ^ toString node ^ "</k>"
      | CW node ->"<w>" ^ toString node ^ "</w>"
let _ = print_string (toString (fullSeq()))

